= Supporting Tools =
[[TOC(heading=About SecureCI™,depth=2,AboutSecureCI/*)]]

== Apache HTTP Server ==

[http://httpd.apache.org/ Apache HTTP Server] is used as the web server for SecureCI™. Access to Trac, Jenkins, GitBlit, 
Tomcat, Sonar, and Nexus are all handled through the Apache HTTP Server.

<% if ::File.directory?("#{node['tomcat']['install_dir']}") %> 
== Tomcat ==

Some of the tools included with SecureCI™ are served by the [http://tomcat.apache.org/ Apache Tomcat] Java 
Servlet engine. Tomcat could also be used for development projects on the SecureCI™ system.

 * [HowTo/AddTomcatInstance How do I add a new Tomcat instance?]

<% end %>
<% if ::File.directory?("#{node['mysql']['data_dir']}") %>
== MySQL ==

Some of the tools included with SecureCI™ store content in the 
[http://www.mysql.com/ MySQL Database Server], in particular Trac and Sonar. MySQL could also be used for development 
projects on the SecureCI™ system.

<% end %>
== Postfix ==

Postfix is Wietse Venema's mail server that started life at IBM research as an alternative to the widely-used Sendmail program.  
Postfix attempts to be fast, easy to administer, and secure. The outside has a definite Sendmail-ish flavor, but the inside is completely different.  

Postfix configuration files are in /etc/postfix. The two most important files are {{{main.cf}}} and {{{master.cf}}}; these files must be owned by root. Giving someone else write permission to {{{main.cf}}} or {{{master.cf}}} (or to their parent directories) means giving root privileges to that person.  
In {{{/etc/postfix/main.cf}}} you will have to set up a minimal number of configuration parameters. Postfix configuration parameters resemble shell variables, with two important differences: the first one is that Postfix does not know about quotes like the UNIX shell does.  

More information can be found [http://www.postfix.org/documentation.html here]

== Python ==

Python is an easy to learn, powerful programming language. It has efficient high-level data structures and a simple but effective approach to object-oriented programming. Python’s elegant syntax and dynamic typing, together with its interpreted nature, make it an ideal language for scripting and rapid application development in many areas on most platforms.  

The Python interpreter and the extensive standard library are freely available in source or binary form for all major platforms from the Python Web site, https://www.python.org/, and may be freely distributed. The same site also contains distributions of and pointers to many free third party Python modules, programs and tools, and additional documentation.  

The Python interpreter is easily extended with new functions and data types implemented in C or C++ (or other languages callable from C). Python is also suitable as an extension language for customizable applications.

== Java ==

SecureCI™ includes [http://java.sun.com/ Sun's Java Development Kit (JDK)]. Many of the tools run using Java, and SecureCI™ was
assembled with Java development in mind.

<% if node['platform'] == "ubuntu" %>
== Ubuntu ==

SecureCI™ is built on the [http://www.ubuntu.com/ Ubuntu Server Edition JeOS <%= node['platform_version'] %> LTS (<%= node['platform_name']['long'] %>)] operating system,
a free OS using the Linux kernel. '''JeOS''' (pronounced ''juice'') stands for 
"[http://www.ubuntu.com/products/whatisubuntu/serveredition/jeos Just enough OS]", and is configured with virtual 
machines in mind. '''LTS''' stands for "[https://wiki.ubuntu.com/LTS Long Term Support]". Security releases are issued 
for LTS Server editions for 5 years after release, which was <%= node['platform_release'] %> (<%= node['platform_version'] %>) in our case. Ubuntu releases are 
sometimes referred to by their code name, in this case '''<%= node['platform_name']['long'] %>''' or often just '''<%= node['platform_name']['short'] %>'''. 
The Server edition does not include a GUI by default.

Applications and system administration processes that work on Ubuntu will work on SecureCI™. 
As Ubuntu is a derivative of [http://www.debian.org/ Debian], Debian processes and packages should work as well.

<% end %>
=== Installation details ===

Apache HTTP is 
installed via `apt-get` with several modules:
 * SSL (with certificates in `/etc/apache2/ssl/`)
 * Python and mod_wsgi (for [../ProjectManagement#Trac Trac])
 * mod_dav and mod_dav_svn (for [../Development#Subversion Subversion])
 * authz authentication (for [../ProjectManagement#Trac Trac] and [../Development#Subversion Subversion])
<% if ::File.directory?("#{node['tomcat']['install_dir']}") %> 
 * mod_proxy  and mod_proxy_ajp (for Tomcat)
<% end %>

[../Development#Jenkins Jenkins], [../Development#Nexus Nexus], [../ProjectManagement#Sonar Sonar], 
and [../Development#GitBlit GitBlit] are proxied via the AJP connector.

<% if ::File.directory?("#{node['tomcat']['install_dir']}") %> 
Tomcat is installed in `/etc/tomcat7`, with the working instance (`CATALINA_BASE`) at `/var/lib/tomcat`. 
The AJP connector is active, running on the default port 8009. The HTTP connector is active on port 8080, but the 
firewall currently blocks remote connections to that port.
<% end %>

[../Development#Jenkins Jenkins] and [../Development#Nexus Nexus] both run standalone and 
are proxied by [../Support#ApacheHTTPServer Apache HTTP Server].

MySQL is installed via `apt-get`, which stores the data in `/var/lib/mysql` by default.

[../ProjectManagement#Trac Trac] and [../ProjectManagement#Sonar Sonar] use MySQL for content storage 
(databases `trac` and `sonar`, respectively).

Java is installed in `<%= node['java']['java_home'] %>`. The `JAVA_HOME` environment variable is set upon user log in via the 
`/etc/profile.d/java.sh` script.

<%= node['trac']['wiki']['footer'] %>